import React, { Component, RefObject } from 'react';
import PropTypes from 'prop-types';
import { TextInput, TextInputProps, Animated, NativeSyntheticEvent, TextInputFocusEventData, TextInputSubmitEditingEventData } from 'react-native';
import { SuggesterContextParam } from './SuggesterContext';
import { IData } from './IData';
export interface SuggestTextInputProps extends TextInputProps {
    data: IData[];
    name: string;
}
interface State {
    value: string | undefined;
    focused: boolean;
}
export declare class SuggestTextInput extends Component<SuggestTextInputProps, State> {
    static propTypes: {
        name: PropTypes.Validator<string>;
        data: PropTypes.Requireable<PropTypes.InferProps<{
            id: PropTypes.Validator<string | number>;
            value: PropTypes.Validator<string>;
        }>[]>;
    };
    state: {
        value: string | undefined;
        focused: boolean;
    };
    translateY: Animated.Value;
    opacity: Animated.Value;
    textInputRef?: RefObject<TextInput>;
    constructor(props: SuggestTextInputProps);
    onSelect: (value: string) => Promise<void>;
    componentDidMount(): void;
    componentWillUnmount(): void;
    handleFocus: ({ setMarginTopAsync, handleFocusProvider, setDataAsync, statusBarHeight, setPaddingHorizontalAsync, }: SuggesterContextParam) => (e: NativeSyntheticEvent<TextInputFocusEventData>) => Promise<void>;
    handleBlur: ({ handleBlurProvider }: SuggesterContextParam) => (e: NativeSyntheticEvent<TextInputFocusEventData>) => void;
    handleChange: ({ setValueAsync }: SuggesterContextParam) => (value: string) => void;
    measureAsync: (ref?: React.RefObject<TextInput> | undefined) => Promise<{
        inputY: number;
        inputHeight: number;
        inputWidth: number;
    }>;
    handleSubmit: (e: NativeSyntheticEvent<TextInputSubmitEditingEventData>) => void;
    render(): JSX.Element;
}
export {};
