var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import React, { Component } from 'react';
import { FlatList, StyleSheet, Text, TouchableOpacity, View, } from 'react-native';
import { SuggesterEventEmitter } from './SuggesterEventEmitter';
const styles = StyleSheet.create({
    item: {
        flex: 1,
        alignItems: 'flex-start',
        justifyContent: 'flex-start',
        paddingVertical: 7,
    },
    empty: {
        alignItems: 'center',
        flex: 1,
        justifyContent: 'center',
    },
});
const SuggesterText = (_a) => {
    var { textColor, textFont } = _a, props = __rest(_a, ["textColor", "textFont"]);
    return (<Text style={[{ color: textColor }, textFont ? { fontFamily: textFont } : {}]} {...props}/>);
};
export class SuggesterModal extends Component {
    constructor() {
        super(...arguments);
        this.keyExtractor = (item) => `${item.id}`;
        this.renderEmpty = () => {
            const { backgroundColor, textColor, textFont } = this.props;
            return (<View style={[styles.empty, { backgroundColor }]}>
        <SuggesterText {...{ textColor, textFont }}>
          {this.props.textWhenEmpty}
        </SuggesterText>
      </View>);
        };
        this.handleSelect = ({ selectFromList, name, value, }) => () => {
            selectFromList(name, value);
            SuggesterEventEmitter.emit(`selectFromList-${name}`, value);
        };
        this.renderItem = (selectFromList) => ({ item, }) => {
            const { backgroundColor, textColor, textFont, currentName, paddingHorizontal, } = this.props;
            return (<TouchableOpacity onPress={this.handleSelect({
                selectFromList,
                name: currentName,
                value: item.value,
            })} style={[styles.item, { backgroundColor, paddingHorizontal }]}>
        <Text style={[
                { color: textColor },
                textFont ? { fontFamily: textFont } : {},
            ]}>
          {item.value}
        </Text>
      </TouchableOpacity>);
        };
    }
    render() {
        const { data, selectFromList, paddingTop } = this.props;
        return (<FlatList style={[StyleSheet.absoluteFill, paddingTop ? { paddingTop } : {}]} keyExtractor={this.keyExtractor} renderItem={this.renderItem(selectFromList)} ListEmptyComponent={this.renderEmpty} keyboardShouldPersistTaps="always" data={data}/>);
    }
}
SuggesterModal.defaultProps = {
    textWhenEmpty: 'Type text, we suggest',
    backgroundColor: 'white',
};
//# sourceMappingURL=SuggesterModal.js.map