import { Component, ReactNode } from 'react';
import { Animated } from 'react-native';
import { IData } from './IData';
import Fuse from 'fuse.js';
export interface Props {
    children: ReactNode;
    statusBarHeight?: number;
    backgroundColor?: string;
    textColor?: string;
    textFont?: string;
    textWhenEmpty?: string;
}
export declare type SuggesterProviderProps = Omit<Props, 'children'>;
interface State {
    data: IData[];
    currentName?: string;
    marginTop: number;
    paddingHorizontal: number;
    values: {
        [name: string]: string;
    };
    focused: boolean;
}
export declare class SuggesterProvider extends Component<SuggesterProviderProps, State> {
    static defaultProps: {
        statusBarHeight: any;
        backgroundColor: string;
        textColor: string;
    };
    state: {
        data: never[];
        currentName: undefined;
        marginTop: number;
        paddingHorizontal: number;
        values: {};
        focused: boolean;
    };
    translateY: Animated.Value;
    fuse?: Fuse<IData>;
    setDataAsync: (name: string, data: IData[]) => Promise<void>;
    setValueAsync: (name: string, value: string) => Promise<void>;
    setMarginTopAsync: (marginTop: number) => Promise<void>;
    handleFocus: () => Promise<void>;
    handleBlur: () => void;
    selectFromList: (name: string, value: string) => Promise<void>;
    getData: () => IData[];
    setPaddingHorizontalAsync: (paddingHorizontal: number) => Promise<void>;
    render(): JSX.Element;
}
export {};
